

; ------------------------
; BaseC v1.0
; By Kaid [kaid@excite.fr]
; ------------------------

#DEFINE TITRE "BaseC 1.0 - Kaid",0
.INCLUDE ZSHELL83.INC

BASE      = saferam3            ;Base courante (2,8,10,16)
NBASE     = saferam3+1          ;Numro de la base courante (0,1,2,3)

STRLEN    = saferam3+2          ;Taille de la saisie
T_SAISIE  = saferam3+3          ;Taille maximale de la saisie
SAISIE    = saferam3+4          ;Buffer de saisie

TEMP     =  saferam3+30         ;Variable temporaire


        CALL InitEcran          ;On initialise l'cran

        LD HL,BaseSauve         ;
        LD A,(HL)               ;La base sauvegarde devient la base
        LD (NBASE),A            ; courante

        CALL InitSaisie         ;On initialise la saisie

; Boucle principale

PresseTouche:
        CALL AttendTouche       ;Attend la pression d'une touche

        CP G_MODE               ;[MODE] presse ?
        RET Z                   ; On quitte

        CP G_DEL                ;[DEL] presse ?
        CALL Z,EffaceCar        ; On efface un caractre

        CP G_UP                 ;[UP] presse ?
        CALL Z,ChxSourceHaut    ; Changement de la base source

        CP G_DOWN               ;[DOWN] presse ?
        CALL Z,ChxSourceBas     ; Changement de la base source 

        CP G_LN                 ;[Ln] presse ?
        CALL Z,SauveBase        ; On sauve la base actuelle

        CP G_ENTER              ;[ENTER] presse ?
        CALL Z,Conversion       ; On effectue la conversion

        CALL TestSaisie         ;On teste s'il ne s'agit pas d'un chiffre

        JR PresseTouche         ;Boucle


; o Effacement d'un caractre dans la chaine o
EffaceCar:
        LD A,(STRLEN)           ;A=Taille de la saisie

        OR A \ RET Z            ;Si la chaine est vide, on sort

        DEC A                   ;
        LD (STRLEN),A           ;Dcrmente et sauvegarde la nouvelle taille

        LD E,A \ LD D,0         ;
        LD HL,SAISIE            ;HL pointe sur le caractre qui vient d'tre
        ADD HL,DE               ; effac

        XOR A                   ;
        LD (HL),A               ;On le remplace par un '\0'

        CALL AffBufSaisie       ;On affiche la saisie
        RET



; o Sauve la base courante o
SauveBase:
        LD A,(NBASE)            ;
        LD HL,BaseSauve         ;On place le contenu de la variable temporaire
        LD (HL),A               ; NBASE dans BaseSauve
        RET                



; o Saisie d'un caractre o
TestSaisie:

        LD C,A                  ;On sauve A

        LD A,(STRLEN) \ LD B,A  ;Taille de la chaine saisie actuellement
        LD A,(T_SAISIE)         ;Taille maximale de la chaine

        CP B                    ;Si A et B sont gaux, la saisie
        RET Z                   ;est complte

        LD A,C                  ;On restaure A
        CALL TransChiffre       ;On transforme la touche saisie en chiffre
        RET Z                   ;Si ZF=1, la touche n'est pas autorise

        PUSH AF                 ;Sauve A (Chiffre)

        LD HL,SAISIE            ;Pointe sur la saisie
        LD DE,STRLEN            ;Pointe sur la taille de la saisie

        LD A,(DE)               ;Taille de la chaine saisie actuelle

        LD C,A \ LD B,0         ;HL pointe maintenant sur l'endroit auquel
        ADD HL,BC               ; on va stocker le nouveau caractre

        EX DE,HL                ;Echange DE et HL
        POP AF

        LD (DE),A               ;On place le caractre
        INC (HL)                ;On incrmente la taille de la saisie

        CALL AffBufSaisie       ;Et on affiche le buffer de saisie
        RET


; o Transforme une touche presse en chiffre o
TransChiffre:

        PUSH AF                 ;On sauve A

        LD A,(BASE)             ;Contient la base courante
        INC A                   ;On l'incrmente
        LD D,A                  ;Et on sauve cette valeur dans D
        LD C,A \ LD B,0         ;BC=A

        LD HL,Touches+15        ;Pointe sur la dernire touche dans la liste

        POP AF                  ;On restaure A (Touche presse)

        CPDR                    ;Recherche A dans (HL)

        LD A,C                  ;A=C (Position de la touche dans la liste)

        OR A \ RET Z            ;Si A=0, la touche n'est pas connue

        LD A,D \ SUB C          ;A=D-C

        ADD A,$30-1             ;Transforme les codes des touches en lettres
        RET


; o Effectue la convertion o
Conversion:
        CALL Str2Dec            ;On convertit la saisie en nombre dcimal
        EX DE,HL                ;Met le nombre dans DE

        CALL AffNombre          ;Affiche le nombre dans les autres bases

        CALL AttendTouche       ;Attend la pression d'une touche        

        CALL InitSaisie         ;Initialise la saisie
        RET     






; o Affiche le buffer de saisie o
AffBufSaisie:

        LD HL,$0002             ;
        LD (CURSOR_ROW),HL      ;On positionne le curseur

        LD HL,SAISIE            ;HL pointe sur la saisie


TransChaine:
        LD A,(HL)               ;A=(HL)

        OR A                    ;
        JR Z, Fin_AffBufSaisie  ;Si A=0, nous sommes en fin de chaine
	
        CP $3A                  ;
        JR C, Chiffre           ;Si A est <$3A, c'est un chiffre

        ADD A,7                 ;On ajoute 7 pour obtenir une lettre

Chiffre:
        bcall(TX_CHARPUT)       ;Affiche du caractre

        INC HL                  ;Pointe sur le prochain caractre
        JR TransChaine          ;On boucle

Fin_AffBufSaisie:

        LD A,$20                ;
        bcall(TX_CHARPUT)       ;On affiche un espace
        RET



; o Convertie une chaine en dcimal o
Str2Dec:
        LD A,(BASE) \ LD B,A    ;B contient la base courante
        LD IX,SAISIE            ;IX pointe vers la saisie
        SBC HL,HL               ;HL va contenir le rsultat

        LD A,(IX)               ;A=(IX)         
        OR A \ RET Z            ;Si A=0, nous sommes  la fin de la chaine

Boucle:
        SUB $30                 ;On retire $30: Code ASCII -> Chiffre

        LD E,A \ LD D,0         ;
        ADD HL,DE               ;On ajoute ce chiffre  HL

        INC IX                  ;Pointe sur le prochain caractre

        LD A,(IX)               ;A=(IX)
        OR A \ RET Z            ;Si A=0, nous sommes  la fin de la chaine

        CALL MUL_HL_B           ;On multiplie HL par B (la base)
        JR Boucle               ;On boucle
	


; o Convertie en nombre dcimal (HL) en une chaine (DE) dans la base <B> o
Num2Str:

        PUSH BC                 ;On sauve BC   
        LD A,B                  ;A=B (Diviseur)
        bcall(_divhlbya)        ;Divise HL par A
        POP BC                  ;On restaure BC

        CP 10                   ;Si A est infrieur  10, il s'agit d'un
        JR C,RChiffre           ; chiffre

        ADD A,7                 ;On ajoute 7  A pour obtenir une lettre

RChiffre:
        ADD A,$30               ;Chiffre -> Caractre ASCII

        DEC DE                  ;On se place sur le caractre prcdent
        LD (DE),A               ;On place le caractre dans la chaine

        XOR A                   ;A=0

        CP H                    ;
        JR NZ,Num2Str           ;Si D!=0, DE!=0, on continue

        CP L                    ;
        JR NZ,Num2Str           ;Si E!=0, DE!=0, on continue

        RET


; o Affiche le nombre saisie dans les 3 autres bases o
AffNombre:
        XOR A                   ;Nombre de convertion  effectuer
        LD BC,$2010             ;Position initiale du curseur

AffNombre_B:
        PUSH AF \ PUSH BC       ;On sauve AF et BC

        LD L, A                 ;L contient le numro de la base  afficher
        LD A,(NBASE)            ;A contient le numro de la base courante

        CP L                    ;S'ils sont gaux, c'est la base source, on
        JR Z,BaseSource         ; n'affiche rien

        PUSH DE \ PUSH BC       ;On sauve DE et BC

        LD BC,Lst_Bases         ;BC pointe sur la liste des bases
        LD H,0                  ;HL=L
        ADD HL,BC               ;HL pointe maintenant sur la bonne base
        LD B,(HL)               ;On place cette base dans B

        LD HL,TEMP+20           ;On se place  la fin du buffer temporaire
        XOR A \ LD (HL),A       ;On y place un '\0'

        EX DE,HL                ;Echange DE et HL
        CALL Num2Str            ;Convertie le nombre en chaine pour la base <B>
        EX DE,HL                ;Echange DE et HL

        POP BC                  ;Restaure BC 
        LD (CURSOR_X),BC        ;On positionne le curseur

        bcall(D_ZM_STR)         ;On affiche la chaine pointe par HL

        POP DE                  ;Restaure DE (nombre saisie)

BaseSource:
        POP BC \ POP AF         ;On restaure BC et AF

        LD HL,$0800 \ ADD HL,BC ;
        PUSH HL \ POP BC        ;BC+=$0800 (Ligne suivante)
        
        INC A                   ;Incrmente A

        CP 4 \ JR NZ,AffNombre_B ;Tant que A!=4, on boucle
        RET



; o Multiplie HL par B o
Mul_HL_b:
        PUSH BC                 ;On sauve B

        DEC B                   ;On dcrmente B

        PUSH HL                 ;
        POP DE                  ;DE=HL

B_Mul_HL_b:     
        ADD HL,DE               ;
        DJNZ B_Mul_HL_b         ;On ajoute <B> fois HL  lui mme

        POP BC                  ;On restaure BC
	RET



;o Attend la pression d'une touche. Code dans A o
AttendTouche:

        bcall(GET_KEY)           ;On lit la touche
        OR A \ JR Z,AttendTouche ;Et on boucle qu'il n'y a pas de touche
        RET


;o Efface les anciennes donnes  l'cran o
Efface:

; Efface la saisie

        LD B,8                  ;Nombre de lignes  effacer
        LD E,0                  

Eff_Saisie_L:
        PUSH BC

        LD B,$B+1               ;Nombre d'octets par ligne
        LD D,0                  
        CALL Eff_Ligne          ;Efface la ligne
        POP BC

        INC E                   ;Incrmente le nombre de lignes traites
        DJNZ Eff_Saisie_L


; Efface les nombres convertis

        LD B,8*4                ;Nombre de lignes  effacer
        LD E,16                 ;Dcalage initial du nombre de lignes

Eff_Base_L:
        PUSH BC

        LD B,$A                 ;Nombre d'octets par ligne
        LD D,2
        CALL Eff_Ligne          ;Efface la ligne
        POP BC

        INC E                   ;Incrmente le nombre de lignes traites
        DJNZ Eff_Base_L
        RET



; o Efface une ligne de pixel o
Eff_Ligne:

        LD A,$20
        ADD A,D                 
        bcall(_Lcdbusy)
        OUT ($10),A             ;Coordonne X

        LD A,$90
        ADD A,E
        bcall(_Lcdbusy)
        OUT ($10),A             ;Coordonne Y

        XOR A                   ;
        bcall(_Lcdbusy)         ;
        OUT ($11),A             ;On efface le pixel

        INC D                   ;Incrmente le nombre d'octets traits
        DJNZ Eff_Ligne
        RET


; o Changement de la base source (vers le haut) o
ChxSourceHaut:

        XOR A           
        LD HL,NBASE             ;HL pointe sur le numro de la base

        CP (HL)                 ;Si ce numro n'est pas gal  0, on peut
        JR NZ, PasYMin          ; le dcrmenter

        LD (HL),4               ;Numro de la dernire base+1

PasYMin:
        DEC (HL)                ;On dcrmente le numro de la base

        JR InitSaisie           ;On va r-initialiser la saisie


; o Changement de la base source (vers le bas) o
ChxSourceBas:

        LD A,3
        LD HL,NBASE             ;HL pointe sur le numro de la base

        CP (HL)                 ;Si ce numro n'est pas gal  3, on peut
        JR NZ, PasYMax          ; l'incrmenter

        LD (HL),$FF             ;Numro de la permire base-1

PasYMax:
        INC (HL)                ;On incrmente le numro de la base


; o Initialise la saisie (Efface les anciennes donnes, l'ancienne saisie, ...) o
InitSaisie:

        CALL Efface             ;On efface les parties non fixes de l'cran       

        XOR A                   ;
        LD (STRLEN),A           ;On met la taille de la saisie  zro

        LD HL,SAISIE            ;
        LD DE,SAISIE+1          ;
        LD BC,17-1              ;
        LD (HL),A               ;
        LDIR                    ;On remplie le buffer de saisie avec des '\0'


; Affiche de "Source" en face de la base correspondante

        LD A,(NBASE)            ;
        PUSH AF                 ;
        LD D,A \ LD E,0         ;
        SLA D \ SLA D \ SLA D   ;DE=A*8

        LD HL,$2010             ;Position du curseur pour la premire base
        ADD HL,DE               ;On effectue le dcalage        
        LD (CURSOR_X),HL        ;Et on positionne le curseur

        LD HL,Str_Source        ;
        bcall(D_ZM_STR)         ;On affiche "Source"


; Charge les infos sur la base courante
        POP AF
        LD E,A \ LD D,0         ;DE=A=NBASE

        LD HL,Lst_Bases         ;
        ADD HL,DE               ;
        LD A,(HL) \ LD (BASE),A ;Base (2,16,10 ou 8)

        LD HL,Lst_Max_Saisie        ;
        ADD HL,DE                   ;
        LD A,(HL) \ LD (T_SAISIE),A ;Taille de la saisie maximale

        RET


;o Initialise l'cran o

InitEcran:
        bcall(CLEARLCD)         ;Efface l'cran

        SET 3,(IY+$05)          ;
        SBC HL,HL               ;
        LD (CURSOR_ROW),HL      ;
        LD HL,TitreIon          ;
        bcall(D_ZT_STR)         ;
        RES 3,(IY+$05)          ;Affichage du titre


; On va afficher les diffrentes bases

        LD B,4                  ;Nombre de chaines
        LD DE,$2000             ;Position initiale du curseur
        LD HL,Str_Bases         ;Pointe sur les chaines

Aff_Bases_L:

        LD (CURSOR_X),DE        ;On place le curseur
        bcall(D_ZM_STR)         ;        

        LD A,D                  ;
        ADD A,8                 ;
        LD D,A                  ;D+=8, soit la prochaine ligne

        DJNZ Aff_Bases_L        ;On boucle

        RET



; o Donnes o
BaseSauve       .DB 0
Lst_Bases       .DB 10,16,02,08
Lst_Max_Saisie  .DB 05,04,16,06


; o Liste des touches o
Touches         .DB G_COS               
                .DB G_SIN
                .DB G_INV
                .DB G_PRGM
                .DB G_MATRIX
                .DB G_MATH
                .DB G_9
                .DB G_8
                .DB G_7
                .DB G_6
                .DB G_5
                .DB G_4
                .DB G_3
                .DB G_2
                .DB G_1
                .DB G_0


; o Chaines o
Str_Bases       .DB "Dec:",0
                .DB "Hex:",0
                .DB "Bin:",0
                .DB "Oct:",0

Str_Source      .DB "Source",0

.END
